/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Relation;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.ErrorG;
private import glib.GException;
private import glib.Str;
private import gobject.ObjectG;


/** */
public class Relation : ObjectG
{
	/** the main Gtk struct */
	protected AsRelation* asRelation;

	/** Get the main Gtk struct */
	public AsRelation* getRelationStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asRelation;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asRelation;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsRelation* asRelation, bool ownedRef = false)
	{
		this.asRelation = asRelation;
		super(cast(GObject*)asRelation, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_relation_get_type();
	}

	/**
	 * Creates a new #AsRelation.
	 *
	 * Returns: a #AsRelation
	 *
	 * Since: 0.11.0
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_relation_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsRelation*) __p, true);
	}

	/**
	 * Converts the text representation to an enumerated value.
	 *
	 * Params:
	 *     compareStr = the string.
	 *
	 * Returns: a #AsRelationCompare, or %AS_RELATION_COMPARE_UNKNOWN for unknown.
	 *
	 * Since: 0.12.0
	 */
	public static AsRelationCompare compareFromString(string compareStr)
	{
		return as_relation_compare_from_string(Str.toStringz(compareStr));
	}

	/**
	 * Converts the enumerated value to an text representation.
	 * The enum is converted into a two-letter identifier ("eq", "ge", etc.)
	 * for use in the XML representation.
	 *
	 * Params:
	 *     compare = the #AsRelationCompare.
	 *
	 * Returns: string version of @compare
	 *
	 * Since: 0.12.0
	 */
	public static string compareToString(AsRelationCompare compare)
	{
		return Str.toString(as_relation_compare_to_string(compare));
	}

	/**
	 * Converts the enumerated value to an text representation.
	 * The enum is converted into an identifier consisting of two
	 * mathematical comparison operators ("==", ">=", etc.)
	 * for use in the YAML representation and user interfaces.
	 *
	 * Params:
	 *     compare = the #AsRelationCompare.
	 *
	 * Returns: string version of @compare
	 *
	 * Since: 0.12.0
	 */
	public static string compareToSymbolsString(AsRelationCompare compare)
	{
		return Str.toString(as_relation_compare_to_symbols_string(compare));
	}

	/**
	 * Converts the text representation to an enumerated value.
	 *
	 * Params:
	 *     kindStr = the string.
	 *
	 * Returns: a #AsRelationItemKind or %AS_RELATION_ITEM_KIND_UNKNOWN for unknown
	 *
	 * Since: 0.12.0
	 */
	public static AsRelationItemKind itemKindFromString(string kindStr)
	{
		return as_relation_item_kind_from_string(Str.toStringz(kindStr));
	}

	/**
	 * Converts the enumerated value to a text representation.
	 *
	 * Params:
	 *     kind = the #AsRelationKind.
	 *
	 * Returns: string version of @kind
	 *
	 * Since: 0.12.0
	 */
	public static string itemKindToString(AsRelationItemKind kind)
	{
		return Str.toString(as_relation_item_kind_to_string(kind));
	}

	/**
	 * Converts the text representation to an enumerated value.
	 *
	 * Params:
	 *     kindStr = the string.
	 *
	 * Returns: a #AsRelationKind or %AS_RELATION_KIND_UNKNOWN for unknown
	 *
	 * Since: 0.12.0
	 */
	public static AsRelationKind kindFromString(string kindStr)
	{
		return as_relation_kind_from_string(Str.toStringz(kindStr));
	}

	/**
	 * Converts the enumerated value to a text representation.
	 *
	 * Params:
	 *     kind = the #AsRelationKind.
	 *
	 * Returns: string version of @kind
	 *
	 * Since: 0.12.0
	 */
	public static string kindToString(AsRelationKind kind)
	{
		return Str.toString(as_relation_kind_to_string(kind));
	}

	/**
	 * The version comparison type.
	 *
	 * Returns: an enum of type #AsRelationCompare
	 *
	 * Since: 0.12.0
	 */
	public AsRelationCompare getCompare()
	{
		return as_relation_get_compare(asRelation);
	}

	/**
	 * The kind of the item of this #AsRelation.
	 *
	 * Returns: an enum of type #AsRelationItemKind
	 *
	 * Since: 0.12.0
	 */
	public AsRelationItemKind getItemKind()
	{
		return as_relation_get_item_kind(asRelation);
	}

	/**
	 * The type (and thereby strength) of this #AsRelation.
	 *
	 * Returns: an enum of type #AsRelationKind
	 *
	 * Since: 0.12.0
	 */
	public AsRelationKind getKind()
	{
		return as_relation_get_kind(asRelation);
	}

	/**
	 * Returns: The value of the item this #AsRelation is about.
	 *
	 * Since: 0.12.0
	 */
	public string getValue()
	{
		return Str.toString(as_relation_get_value(asRelation));
	}

	/**
	 * Get the value of this #AsRelation item as #AsControlKind if the
	 * type of this relation is %AS_RELATION_ITEM_KIND_CONTROL.
	 * Otherwise return %AS_CONTROL_KIND_UNKNOWN
	 *
	 * Returns: a #AsControlKind or %AS_CONTROL_KIND_UNKNOWN in case the item is not of the right kind.
	 *
	 * Since: 0.12.11
	 */
	public AsControlKind getValueControlKind()
	{
		return as_relation_get_value_control_kind(asRelation);
	}

	/**
	 * Returns: The value of this #AsRelation item as an integer. Returns 0 if the value was no integer.
	 *
	 * Since: 0.12.0
	 */
	public int getValueInt()
	{
		return as_relation_get_value_int(asRelation);
	}

	/**
	 * Returns: The version of the item this #AsRelation is about.
	 *
	 * Since: 0.12.0
	 */
	public string getVersion()
	{
		return Str.toString(as_relation_get_version(asRelation));
	}

	/**
	 * Set the version comparison type of this #AsRelation.
	 *
	 * Params:
	 *     compare = the new #AsRelationCompare
	 *
	 * Since: 0.12.0
	 */
	public void setCompare(AsRelationCompare compare)
	{
		as_relation_set_compare(asRelation, compare);
	}

	/**
	 * Set the kind of the item this #AsRelation is about.
	 *
	 * Params:
	 *     kind = the new #AsRelationItemKind
	 *
	 * Since: 0.12.0
	 */
	public void setItemKind(AsRelationItemKind kind)
	{
		as_relation_set_item_kind(asRelation, kind);
	}

	/**
	 * Set the kind of this #AsRelation.
	 *
	 * Params:
	 *     kind = the new #AsRelationKind
	 *
	 * Since: 0.12.0
	 */
	public void setKind(AsRelationKind kind)
	{
		as_relation_set_kind(asRelation, kind);
	}

	/**
	 * Sets the item value.
	 *
	 * Params:
	 *     value = the new value.
	 *
	 * Since: 0.12.0
	 */
	public void setValue(string value)
	{
		as_relation_set_value(asRelation, Str.toStringz(value));
	}

	/**
	 * Sets the item version.
	 *
	 * Params:
	 *     version_ = the new version.
	 *
	 * Since: 0.12.0
	 */
	public void setVersion(string version_)
	{
		as_relation_set_version(asRelation, Str.toStringz(version_));
	}

	/**
	 * Tests whether the version number of this #AsRelation is fulfilled by
	 * @version. Whether the given version is sufficient to fulfill the version
	 * requirement of this #AsRelation is determined by its comparison resraint.
	 *
	 * Params:
	 *     version_ = a version number, e.g. `1.2.0`
	 *
	 * Returns: %TRUE if the version from the parameter is sufficient.
	 *
	 * Since: 0.12.0
	 *
	 * Throws: GException on failure.
	 */
	public bool versionCompare(string version_)
	{
		GError* err = null;

		auto __p = as_relation_version_compare(asRelation, Str.toStringz(version_), &err) != 0;

		if (err !is null)
		{
			throw new GException( new ErrorG(err) );
		}

		return __p;
	}
}
