/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.ValidatorIssue;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import gobject.ObjectG;


/** */
public class ValidatorIssue : ObjectG
{
	/** the main Gtk struct */
	protected AsValidatorIssue* asValidatorIssue;

	/** Get the main Gtk struct */
	public AsValidatorIssue* getValidatorIssueStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asValidatorIssue;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asValidatorIssue;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsValidatorIssue* asValidatorIssue, bool ownedRef = false)
	{
		this.asValidatorIssue = asValidatorIssue;
		super(cast(GObject*)asValidatorIssue, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_validator_issue_get_type();
	}

	/**
	 * Creates a new #AsValidatorIssue.
	 *
	 * Returns: a #AsValidatorIssue
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_validator_issue_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsValidatorIssue*) __p, true);
	}

	/**
	 * The component-id this issue is about.
	 *
	 * Returns: a component-id.
	 */
	public string getCid()
	{
		return Str.toString(as_validator_issue_get_cid(asValidatorIssue));
	}

	/**
	 * Get an extended explanation on this issue, or return %NULL
	 * if none is available.
	 *
	 * Returns: the explanation
	 *
	 * Since: 0.12.8
	 */
	public string getExplanation()
	{
		return Str.toString(as_validator_issue_get_explanation(asValidatorIssue));
	}

	/**
	 * The name of the file this issue was found in.
	 *
	 * Returns: the filename
	 */
	public string getFilename()
	{
		return Str.toString(as_validator_issue_get_filename(asValidatorIssue));
	}

	/**
	 * Get a short context hint for this issue.
	 *
	 * Returns: the hint
	 *
	 * Since: 0.12.8
	 */
	public string getHint()
	{
		return Str.toString(as_validator_issue_get_hint(asValidatorIssue));
	}

	/**
	 * This function is deprecated and should not be used in new code.
	 *
	 * Returns: a #AsIssueSeverity
	 */
	public AsIssueSeverity getImportance()
	{
		return as_validator_issue_get_importance(asValidatorIssue);
	}

	/**
	 * Gets the line number where this issue was found.
	 *
	 * Returns: the line number where this issue occured, or -1 if unknown.
	 */
	public glong getLine()
	{
		return as_validator_issue_get_line(asValidatorIssue);
	}

	/**
	 * Builds a string containing all information about the location
	 * where this issue occured that we know about.
	 *
	 * Returns: the location hint as string.
	 */
	public string getLocation()
	{
		auto retStr = as_validator_issue_get_location(asValidatorIssue);

		scope(exit) Str.freeString(retStr);
		return Str.toString(retStr);
	}

	/**
	 * This function is deprecated.
	 *
	 * Returns: the message
	 */
	public string getMessage()
	{
		return Str.toString(as_validator_issue_get_message(asValidatorIssue));
	}

	/**
	 * Gets the severity of this issue.
	 *
	 * Returns: a #AsIssueSeverity
	 */
	public AsIssueSeverity getSeverity()
	{
		return as_validator_issue_get_severity(asValidatorIssue);
	}

	/**
	 * Gets the issue tag string for this issue.
	 *
	 * Returns: the tag
	 *
	 * Since: 0.12.8
	 */
	public string getTag()
	{
		return Str.toString(as_validator_issue_get_tag(asValidatorIssue));
	}

	/**
	 * Sets the component-id this issue is about.
	 *
	 * Params:
	 *     cid = a component-id.
	 */
	public void setCid(string cid)
	{
		as_validator_issue_set_cid(asValidatorIssue, Str.toStringz(cid));
	}

	/**
	 * Set explanatory text for this issue.
	 *
	 * Params:
	 *     explanation = the explanation.
	 *
	 * Since: 0.12.8
	 */
	public void setExplanation(string explanation)
	{
		as_validator_issue_set_explanation(asValidatorIssue, Str.toStringz(explanation));
	}

	/**
	 * Sets the name of the file the issue was found in.
	 *
	 * Params:
	 *     fname = the filename.
	 */
	public void setFilename(string fname)
	{
		as_validator_issue_set_filename(asValidatorIssue, Str.toStringz(fname));
	}

	/**
	 * Sets short issue hint.
	 *
	 * Params:
	 *     hint = the hint.
	 *
	 * Since: 0.12.8
	 */
	public void setHint(string hint)
	{
		as_validator_issue_set_hint(asValidatorIssue, Str.toStringz(hint));
	}

	/**
	 * This function is deprecated and should not be used in new code.
	 *
	 * Params:
	 *     importance = the #AsIssueSeverity.
	 */
	public void setImportance(AsIssueSeverity importance)
	{
		as_validator_issue_set_importance(asValidatorIssue, importance);
	}

	/**
	 * Sets the line number where this issue was found.
	 *
	 * Params:
	 *     line = the line number.
	 */
	public void setLine(glong line)
	{
		as_validator_issue_set_line(asValidatorIssue, line);
	}

	/**
	 * This function is deprecated.
	 *
	 * Params:
	 *     message = the message text.
	 */
	public void setMessage(string message)
	{
		as_validator_issue_set_message(asValidatorIssue, Str.toStringz(message));
	}

	/**
	 * Sets the severity for this issue.
	 *
	 * Params:
	 *     severity = the #AsIssueSeverity.
	 */
	public void setSeverity(AsIssueSeverity severity)
	{
		as_validator_issue_set_severity(asValidatorIssue, severity);
	}

	/**
	 * Sets the issue tag.
	 *
	 * Params:
	 *     tag = the tag.
	 *
	 * Since: 0.12.8
	 */
	public void setTag(string tag)
	{
		as_validator_issue_set_tag(asValidatorIssue, Str.toStringz(tag));
	}
}
